﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using cipeinet;


   
namespace C_Sharp_Demo
{
 
    public partial class Form1 : Form
    {
        EasyIntegrator easyIntegrator = new cipeinet.EasyIntegrator();
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {                          

            if (System.IO.File.Exists("Setup1.txt"))
            {
                TextBox_Setup.Text = System.IO.File.ReadAllText("Setup1.txt");
            }
            else
            {
                System.IO.File.WriteAllText(@"Setup1.txt","");
            }
        }

        private void Button_Setup_Click(object sender, EventArgs e)
        {
            TextBox_Setup.Text = easyIntegrator.Setup(TextBox_Setup.Text); // save this per PC as this could contain hardware specific settings like COM ports etc.
            System.IO.File.WriteAllText(@"Setup1.txt", TextBox_Setup.Text);
        }

        private void Button_CreditSale_Click(object sender, EventArgs e)
        {
            TextBox_ResultFields.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.Clear();
            easyIntegrator.transFields.AmountTotal = Double.Parse(TextBox_AmountTotal.Text);
            easyIntegrator.transFields.Cashier = TextBox_Cashier.Text;
            easyIntegrator.transFields.TransactionReference = TextBox_TransactionReference.Text;
            if (easyIntegrator.CreditSale())
            {
                TextBox_UniqueTransRef.Text = easyIntegrator.resultsFields.UniqueTransID;
                textBox_token.Text = easyIntegrator.resultsFields.UniqueTransID;           
                MessageBox.Show("Approved.....print receipts using data returned in easyIntegrator1.ResultFields");
                PrintReceipt();                              
                ConvertSignature();
            }
            else
            {
                MessageBox.Show("Declined....code here to ask for another form of payment etc");
            }
        }

        private void Button_CreditReturn_Click(object sender, EventArgs e)
        {
            TextBox_ResultFields.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.Clear();
            easyIntegrator.transFields.AmountTotal = Double.Parse(TextBox_AmountTotal.Text);
            easyIntegrator.transFields.Cashier = TextBox_Cashier.Text;
            easyIntegrator.transFields.TransactionReference = TextBox_TransactionReference.Text;
            if (easyIntegrator.CreditReturn())
            {
                TextBox_UniqueTransRef.Text = easyIntegrator.resultsFields.UniqueTransID;
                textBox_token.Text = easyIntegrator.resultsFields.UniqueTransID;
                MessageBox.Show("Approved.....print receipts using data returned in easyIntegrator1.ResultFields");
                PrintReceipt();                            
                ConvertSignature();
            }
            else
            {
                MessageBox.Show("Declined....code here to ask for another form of payment etc");
            }
        }

        private void Button_DebitSale_Click(object sender, EventArgs e)
        {
            TextBox_ResultFields.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.Clear();
            easyIntegrator.transFields.AmountTotal = Double.Parse(TextBox_AmountTotal.Text);
            easyIntegrator.transFields.Cashier = TextBox_Cashier.Text;
            easyIntegrator.transFields.TransactionReference = TextBox_TransactionReference.Text;
            if (easyIntegrator.DebitSale())
            {
                TextBox_UniqueTransRef.Text = easyIntegrator.resultsFields.UniqueTransID;
                textBox_token.Text = easyIntegrator.resultsFields.UniqueTransID;
                MessageBox.Show("Approved.....print receipts using data returned in easyIntegrator1.ResultFields");
                PrintReceipt();
                ConvertSignature();                                   
            }
            else
            {
                MessageBox.Show("Declined....code here to ask for another form of payment etc");
            }
        }

        private void Button_DebitReturn_Click(object sender, EventArgs e)
        {
            TextBox_ResultFields.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.Clear();
            easyIntegrator.transFields.AmountTotal = Double.Parse(TextBox_AmountTotal.Text);
            easyIntegrator.transFields.Cashier = TextBox_Cashier.Text;
            easyIntegrator.transFields.TransactionReference = TextBox_TransactionReference.Text;
            if (easyIntegrator.DebitReturn())
            {
                TextBox_UniqueTransRef.Text = easyIntegrator.resultsFields.UniqueTransID;
                textBox_token.Text = easyIntegrator.resultsFields.UniqueTransID;
                MessageBox.Show("Approved.....print receipts using data returned in easyIntegrator1.ResultFields");
                PrintReceipt();                             
                ConvertSignature();
            }
            else
            {
                MessageBox.Show("Declined....code here to ask for another form of payment etc");
            }
        }

        private void Button_SaveToken_Click(object sender, EventArgs e)
        {
            TextBox_ResultFields.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.Clear();
            if (easyIntegrator.CreditSaveCard())
            {
                textBox_token.Text = easyIntegrator.resultsFields.UniqueTransID;
                MessageBox.Show("Token generated. Save to use on future sales.");            
            }
        }

        private void Button_TokenSale_Click(object sender, EventArgs e)
        {
            TextBox_ResultFields.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.Clear();
            easyIntegrator.transFields.AmountTotal = Double.Parse(TextBox_AmountTotal.Text);
            easyIntegrator.transFields.Cashier = TextBox_Cashier.Text;
            easyIntegrator.transFields.TransactionReference = TextBox_TransactionReference.Text;
            easyIntegrator.transFields.UniqueTransRef = textBox_token.Text;
            if (easyIntegrator.CreditSale())
            {
                MessageBox.Show("Approved.....print receipts using data returned in easyIntegrator1.ResultFields");
                TextBox_UniqueTransRef.Text = easyIntegrator.resultsFields.UniqueTransID;
                PrintReceipt();                            
                ConvertSignature();                  
            }
            else
            {
                MessageBox.Show("Declined....code here to ask for another form of payment etc");
            }
                    
        }

        private void Button_GenericVoid_Click(object sender, EventArgs e)
        {
            TextBox_ResultFields.Clear();
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.Clear();
            easyIntegrator.transFields.UniqueTransRef = TextBox_UniqueTransRef.Text;
            if (easyIntegrator.GenericVoid())
            {              
                MessageBox.Show("Approved.....Transaction Voided");
                PrintReceipt();
                ConvertSignature();           
            }
            else
            {
                MessageBox.Show("Declined....Transaction cannot be voided");
            }
        }

        private void Button_RequestSignature_Click(object sender, EventArgs e)
        {
            easyIntegrator.LoadSetup(TextBox_Setup.Text);
            easyIntegrator.transFields.Cashier = TextBox_Cashier.Text;
            easyIntegrator.transFields.TransactionReference = TextBox_TransactionReference.Text;
            easyIntegrator.Clear();
            if (easyIntegrator.requestSignature())
            {                             
                ConvertSignature();
            }
        }

        private void PrintReceipt()
        {
            TextBox_ResultFields.AppendText(string.Concat("                              Date: ", DateTime.Now.ToString(), "\r\n\r\n"));
            TextBox_ResultFields.AppendText("Merchandise Description and Price etc.\r\n");
            TextBox_ResultFields.AppendText("Merchandise Description and Price etc.\r\n\r\n\r\n");
            TextBox_ResultFields.AppendText(string.Concat("                              Total: ", TextBox_AmountTotal.Text, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("Acct: ", easyIntegrator.resultsFields.MaskedAccount, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("CardType: ", easyIntegrator.resultsFields.AccountCardType, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("Transaction Type: ", easyIntegrator.resultsFields.TransactionType, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("Approval Code: ", easyIntegrator.resultsFields.ApprovalNumberResult, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("Entry Method: ", easyIntegrator.resultsFields.AccountEntryMethod, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("Batch: ", easyIntegrator.resultsFields.BatchNumber, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("Currency: ", easyIntegrator.resultsFields.CurrencyIndicator, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("Mode: ", easyIntegrator.resultsFields.AuthorizationMode, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("AID: ", easyIntegrator.resultsFields.AID, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("TVR: ", easyIntegrator.resultsFields.TVR, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("IAD: ", easyIntegrator.resultsFields.IAD, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("TSI: ", easyIntegrator.resultsFields.TSI, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("ARC: ", easyIntegrator.resultsFields.ARC, "\r\n"));
            TextBox_ResultFields.AppendText(string.Concat("CVM: ", easyIntegrator.resultsFields.CardHolderVerificationMethod, "\r\n\r\n\r\n"));
            if (easyIntegrator.resultsFields.TransactionType == "CreditSale")
            {
                TextBox_ResultFields.AppendText("             I AGREE TO PAY ABOVE\r\n");
                TextBox_ResultFields.AppendText("         TOTAL AMOUNT ACCORDING\r\n");
                TextBox_ResultFields.AppendText("        TO CARD ISSUER AGREEMENT\r\n\r\n\r\n\r\n");
                TextBox_ResultFields.AppendText("X_______________________________\r\n");
            }
            TextBox_ResultFields.AppendText(string.Concat(easyIntegrator.resultsFields.BillingName, "\r\n\r\n\r\n"));            
        }

        private void ConvertSignature()
        {
            string sigFilename = string.Concat("sig_", DateTime.Now.ToString("yyyy-MM-dd HH.mm.ss"), ".bmp");
            easyIntegrator.utilities.SaveSignatureAsBMP(easyIntegrator.resultsFields.Signature, sigFilename);
            if (File.Exists(sigFilename))
                {
                    SignatureBox.Image = Image.FromFile(sigFilename);
                }
            else
                {
                    SignatureBox.Image = new Bitmap(1, 1);
                }
        }       
    }
}
